<script>
	import { createEventDispatcher } from "svelte"

	import { isLight } from "@/stores/static"

	export let type = "primary"
	export let is = "div"
	export let fullwidth = false
	export let href = ""
	export let target = ""
	export let loading = false
	export let hover = false
	export let align = "center"
	export let size

	const dispatch = createEventDispatcher()

	$: bindClass = (() => {
		let justify = "is-justify-content-"

		switch (align) {
			case "left":
				justify += "flex-start"
				break
			case "right":
				justify += "flex-end"
				break
			case "justify":
				justify += "space-between"
				break
			default:
				justify += "center"
				break
		}

		return `${justify} ${size || ""}`
	})();

	const click = () => dispatch("click")
</script>

<template lang="pug">
svelte:element.button.is-inline-flex.is-align-items-center( 
	this='{is}'
	type='{type}'
	class='{bindClass}'
	class:has-icon!='{$$slots["icon-left"] || $$slots["icon-right"]}'
	class:has-icon-left!='{$$slots["icon-left"]}'
	class:has-icon-right!='{$$slots["icon-right"]}'
	class:is-fullwidth='{fullwidth}'
	class:is-loading='{loading}'
	class:hover='{hover}'
	class:dark='{!$isLight}'
	href='{href}'
	target='{target}'
	on:click='{click}' )
	slot( name="icon-left" )
	+if('$$slots.default')
		span: slot
	slot( name="icon-right" )
</template>

<style lang="scss">
.button {
	padding: 1rem;
	transition: background .2s ease-in-out;
	position: relative;
	cursor: pointer;

	&.small {
		padding: .5rem;
	}

	* {
		user-select: none;
	}
	span {
		font-size: 1.125rem;
		font-weight: 500;
		color: $black;
		transition: color .2s ease-in-out;
	}
	:global(span+span) {
		margin-left: .5rem;
	}
	:global(.icon) {
		height: 1.5rem;
		width: 1.5rem;
		display: flex;
		align-items: center;
		justify-content: center;
	}

	:global(svg path) {
		fill: $black;
		transition: fill .2s ease-in-out;
	}

	&.is-fullwidth {
		width: 100%;
	}

	&.is-loading {
		:global(span) {
			opacity: 0;
		}
		&::after {
			display: block;
			content: "";
			width: 2rem;
			height: 2rem;
			border-radius: 50%;
			border: 2px solid $black;
			border-left-color: transparent;
			border-top-color: transparent;
			animation: rotate reverse .75s infinite linear;
			margin: auto;
			position: absolute;
			top: 0;
			right: 0;
			bottom: 0;
			left: 0;
		}
	}
	@keyframes rotate{ 0% {-webkit-transform: rotate(0deg);-moz-transform: rotate(0deg);-ms-transform: rotate(0deg);transform: rotate(0deg);} 100% {-webkit-transform: rotate(-360deg);-moz-transform: rotate(-360deg);-ms-transform: rotate(-360deg);transform: rotate(-360deg);}}

	$types: (
		"primary": (
			$primary,
			$primary-light,
			$primary
		),
		"tab": (
			$gray,
			$gray-dark,
			$gray-darkest
		),
		"gray": (
			$gray-dark,
			$primary,
			$primary-dark
		),
		"input": (
			#373434,
			#484646,
			#373434
		)
	);

	@each $name, $colors in $types {
		$default: nth($colors, 1);
		$hover: nth($colors, 2);
		$active: nth($colors, 3);

		&[type="#{$name}"] {
			background: $default;

			&.dark {
				@if $name == "gray" or $name == "tab" {
					background: #434343;
					span {
						color: $white;
					}
					:global(svg path) {
						fill: $white;
					}

					&:hover,
					&.hover {
						span {
							color: #1D1D1D;
						}
						:global(svg path) {
							fill: #1D1D1D;
						}
					}
				}
				@if $name == "input" {
					background: #434343;
				}
			}

			@if $name == "input" {
				padding: .75rem 1rem;
				span {
					color: $white;
					font-weight: 300;
				}
				:global(span+span) {
					margin-left: .1875rem;
				}
				:global(.icon) {
					width: 1rem;
					height: 1rem;
				}
				:global(svg path) {
					fill: $white;
				}
				&.is-loading {
					&::after {
						border: 2px solid $white;
						border-left-color: transparent;
						border-top-color: transparent;
					}
				}
			}

			&:hover,
			&.hover {
				background: $hover;
			}

			&:active {
				background: $active;
			}
		}
	}
}
</style>